/**
Used by the Ready...Set...Goal plan page in Careback.
Note: not all users get this page.

This method creates a printer-friendly version of the user's SMART Goals.
There is a known issue that prevents users from printing this in Safari for Windows only.

MLong 10/28/2008 initial version
*/
function printSMARTGoals(pageTitle) {
	var SMARTGoalsWindow = window.open('/helpfile.html','SMARTGoals','width=600,location=no,toolbar=yes,status=yes,scrollbars=yes,resizable=yes,menubar=yes');
	SMARTGoalsWindow.document.location="about:blank";
	SMARTGoalsWindow.document.write('<html><head><title>' + pageTitle + '</title><link rel="stylesheet" type="text/css" href="/css/base/base_global.css" /><link rel="stylesheet" type="text/css" href="/css/base/base_careback.css" /></head><body><div id="cfyb_smart_goals_print">' + document.getElementById('cfyb_smart_goals').innerHTML + '</div>&nbsp;</body></html>');
	SMARTGoalsWindow.document.title=pageTitle;
	SMARTGoalsWindow.document.close();
	SMARTGoalsWindow.document.focus();
}

/**
 * This function finds all the children of the given parent and applies the given class to them,
 * then finds the specified element and applies the given class to it - presumably this class is
 * used to toggle elements on and off.
 * 
 * jgerman	09/15/2009 initial version
 * 
 * @param elementToShow
 * @param parentOfToHides
 * @param classNameThatShows
 * @param classNameThatHides
 * @return
 */
function showAndHide(elementToShow, parentOfToHides, classNameThatShows, classNameThatHides) {
	var parent = document.getElementById(parentOfToHides);
	if (parent.nodeName == 'DIV') {
		var toHides = parent.getElementsByTagName('div');
	} else if (parent.nodeName == 'UL') {
		var toHides = parent.getElementsByTagName('li');
	}
	for (i=0; i<toHides.length; i++) {
		if (toHides[i].parentNode == parent) {
			toHides[i].className = classNameThatHides;
		}
	}
	document.getElementById(elementToShow).className = classNameThatShows;
}

function showAndHideAndChangeLink(elementToShow, classNameThatShows, classNameThatHides) {
	/* if hiding the open element, do so and return */ 
	if (document.getElementById(elementToShow).className == classNameThatShows) {
		document.getElementById(elementToShow).className = classNameThatHides;
		try {
			document.getElementById(elementToShow+'show').className = 'displayLinkBlock';
		} catch (ignore) {/* don't cause an error because of a null */}
		try {
			document.getElementById(elementToShow+'hide').className = 'displayLinkNone';
		} catch (ignore) {/* don't cause an error because of a null */}
		return;
	}

	/* otherwise, find element to hide and do so, then show element selected */
	var toHides = getElementsByClassName('behaviorsContentMiddleShow', 'div', document.getElementById('content'));
	for (i=0; i<toHides.length; i++) {
		toHides[i].className = classNameThatHides;
		var tempID = toHides[i].id;
		try {
			document.getElementById(tempID+'show').className = 'displayLinkBlock';
		} catch (ignore) {/* don't cause an error because of a null */}
		try {
			document.getElementById(tempID+'hide').className = 'displayLinkNone';
		} catch (ignore) {/* don't cause an error because of a null */}
	}
	document.getElementById(elementToShow).className = classNameThatShows;
	try {
		document.getElementById(elementToShow+'show').className = 'displayLinkNone';
	} catch (ignore) {/* don't cause an error because of a null */}
	try {
		document.getElementById(elementToShow+'hide').className = 'displayLinkBlock';
	} catch (ignore) {/* don't cause an error because of a null */}
}

/**
 * This function changes the src and alt of the image with the given id to the given value
 * 
 * jgerman	09/16/2009 initial version
 * 
 * @param imgElementID
 * @param newURL
 * @return
 */
function setImage(imgElementID, newURL) {
	var imgToChange = document.getElementById(imgElementID);
	imgToChange.src = newURL;
	imgToChange.alt = newURL;
}

/**used in the First and Second pages of the Move Guide. These pages have a form on the Guide page.
This function sets the action for the form and then submits it.

qzafar 10/20/08 initial version
kmeadows 09/25/09 modified so elementid is consistently used instead of hardcoded id
*/
function guideFormSubmit(elementid, actionUrl) {
	if(document.getElementById(elementid)){
		document.getElementById(elementid).action=actionUrl;
		document.getElementById(elementid).submit();
	}	
}

/* this method is used to show the full story in a plan callout.  currently,
it's only being used by Depression and Hip*/
function showFullExpandableContent(parentID) {
	document.getElementById(parentID).className='plan_callout_content full_content';
}

/* this method is used to collapse the full story in a plan callout.  currently,
it's only being used by Depression and Hip*/
function collapseFullExpandableContent(parentID) {
	document.getElementById(parentID).className='plan_callout_content partial_content';
}

/* this method is used to show a plan popup.  currently,
it's only being used by Hip*/
function showFullPopupContent(parentID) {
	document.getElementById(parentID).className='plan_popup_show';
}

/* this method is used to collapse a plan popup.  currently,
it's only being used by Hip */
function collapseFullPopupContent(parentID) {
	document.getElementById(parentID).className='plan_popup_collapse';
}

/**
Used to submit the trigger/phase change form for Hip that's available
to the user prior to submitting the baseline questionnaire.

mlong 4/27/2009 initial version
*/
function submitHipPreQChangePhaseForm() {
	var formObj = document.phase_change_pre_submit_quest_form;
	var optionValueSelected = getHipChangePhaseFormSelectedOption(formObj);
	var isNoChangeOptionClicked = (optionValueSelected == 'None');
	
	if (optionValueSelected == '') {
		document.getElementById('error_text').style.display='block';
	} else if (isNoChangeOptionClicked) {
		document.location.href=formObj.BaselineQURL.value;
	} else {
		showHipPhaseChangeConfirmation(optionValueSelected);
	}
}

/**
Used to submit the trigger/phase change form for Hip that's available
to the user after submitting the baseline questionnaire.

mlong 4/27/2009 initial version
*/
function submitHipPostQChangePhaseForm() {
	var formObj = document.phase_change_trigger_form;
	var optionValueSelected = getHipChangePhaseFormSelectedOption(formObj);
	
	if (optionValueSelected == '') {
		document.getElementById('error_text').style.display='block';
	} else {
		showHipPhaseChangeConfirmation(optionValueSelected);
	}
}

/**
A Hip program helper method used for retrieving the selected phase/lmptype to
migrate to for the passed in form object.

mlong 4/27/2009 initial version
*/
function getHipChangePhaseFormSelectedOption(formObj) {
	var optionCount =  formObj.pro.length;
	var optionValueSelected = '';
	
	for (var i=0;i<optionCount;i++) {
		if (formObj.pro[i].checked) {
			optionValueSelected = formObj.pro[i].value;
		}
	}
	return optionValueSelected;
}

/**
Used for displaying the Hip program phase/change confirmation form.

mlong 4/27/2009 initial version
*/
function showHipPhaseChangeConfirmation(phaseToMigrateTo) {
	document.phase_change_confirm_form.pro.value=phaseToMigrateTo;
	document.getElementById('phase_change_confirmation').style.display='block';
}

/**
Used for hiding the Hip program phase/change confirmation form.

mlong 4/27/2009 initial version
*/
function hideHipPhaseChangeConfirmation() {
	document.getElementById('phase_change_confirmation').style.display='none';
}

/**
Used for submitting the Hip program phase/change confirmation form.

mlong 4/27/2009 initial version
mlong 5/15/2009 updated to not do anything if no option is selected
oulupinar 01/16/2010 updated to submit the Hip Phase Change Confirmation form. Issue 24463.
		 design of the page is changes from radio button to cormation button.
*/
function submitHipPhaseChangeConfirm() {
	var formObj = document.phase_change_confirm_form;
	formObj.submit();	
}

/**
Used for submitting the Hip program phase/lmptype gating form.

mlong 4/27/2009 initial version
*/
function submitHipGatingForm() {
	var formObj = document.phase_change_trigger_form;
	
	if (getHipChangePhaseFormSelectedOption(formObj) == '') {
		document.getElementById('error_text').style.display='block';
	} else {
		formObj.submit();
	}
}

function changeHipGatingOption(selectedPhase) {
	try {
		document.getElementById('hip_phase_option_betterhipa').className='hip_phase_option';
		document.getElementById('hip_phase_option_betterhipb').className='hip_phase_option';
		document.getElementById('hip_phase_option_betterhipc').className='hip_phase_option';
	} catch(e) {
		//don't do anything...just don't show a JS error.  this functionality is strictly for design purposes
	}
	document.getElementById('hip_gating_q_header').className='hip_gating_' + selectedPhase + '_header';
	document.getElementById('hip_phase_option_' + selectedPhase).className='hip_phase_option hip_phase_option_selected';
}

function hipMedicalChecklistPopup() {
	window.open('/toolbox/hipprinterfriendlychecklist.html','checklistpopup','menubar,toolbar,scrollbars,left=30px,top=40px,height=400px,width=625px');
}


/**
Show the Hip B program change surgery date form.

bramirez 6/5/2009 initial version
*/
function showSurgeryDateChangeConfirmation() {
	document.getElementById('change_surgery_confirmation').style.display='block';
}

/**
Cancel the Hip B program change surgery date form.

bramirez 6/5/2009 initial version
*/
function cancelChangeSurgeryConfirm() {
	document.getElementById('change_surgery_confirmation').style.display='none';
}

/**
Submit the Hip B program change surgery date form.

bramirez 6/5/2009 initial version
oulupinar 01/13/2010 adding form validation. It is checking to see 
		     if the date is in valid form and if it is the in given
		     range. The date cannot be prior to today's year -"before"
		     nor later than today's year + "after".
		     Issue number 20378.
*/
function submitChangeSurgeryConfirm(before, after) {
	var formObj = document.change_surgery_confirmation_form;
	var formInputObj = formObj.surgerydate;

	if (isDate(formInputObj.value, before, after)==false){
		formInputObj.focus();
		return false;
	}
    	else {	
		formObj.submit();
	}
}


/**
Check that the parameter is an integer (number).

oulupinar 01/13/2010 initial version 
*/
function isInteger(s){
	var i;
	for (i = 0; i < s.length; i++){
		// Check that current character is number.
		var c = s.charAt(i);
		if (((c < "0") || (c > "9"))) {
			return false;
		}
	}
	// All characters are numbers.
	return true;
}

function stripCharsInBag(s, bag){
	var i;
    	var returnString = "";
    	// Search through string's characters one by one.
    	// If character is not in bag, append to returnString.
    	for (i = 0; i < s.length; i++){
        	var c = s.charAt(i);
        	if (bag.indexOf(c) == -1) {
        		returnString += c;
        	}
    }
    return returnString;
}

/**
Check if the month of February has 29 days in passed year (parameter).

oulupinar 01/13/2010 initial version 
*/
function daysInFebruary (year){
	// February has 29 days in any year evenly divisible by four,
    	// EXCEPT for centurial years which are not also divisible by 400.
    	
    	return (((year % 4 == 0) && ( (!(year % 100 == 0)) || (year % 400 == 0))) ? 29 : 28 );
}

function DaysArray(n) {
	for (var i = 1; i <= n; i++) {
		this[i] = 31;
		if (i==4 || i==6 || i==9 || i==11) {
			this[i] = 30;
		}
		if (i==2) {
			this[i] = 29;
		}
   	}
  	return this;
}

/**
Checks if the given date is in valid date format(mm/dd/yyyy).
It also validates if the date after "before" years 
prior today and before "after" years from today.Eg.
date should be in the following range:
today-before < date < today + after

oulupinar 01/13/2010 initial version 
*/
function isDate(dtStr, before, after){
	if(!dtStr) {
		return true;
	}

	var dtCh = "/";
	
	var daysInMonth = DaysArray(12);
	var pos1=dtStr.indexOf(dtCh);
	var pos2=dtStr.indexOf(dtCh,pos1+1);
	var strMonth=dtStr.substring(0,pos1);
	var strDay=dtStr.substring(pos1+1,pos2);
	var strYear=dtStr.substring(pos2+1);
	
	strYr=strYear;
	
	if (strDay.charAt(0)=="0" && strDay.length>1) {
		strDay=strDay.substring(1);
	}
	if (strMonth.charAt(0)=="0" && strMonth.length>1) {
		strMonth=strMonth.substring(1);
	}
	for (var i = 1; i <= 3; i++) {
		if (strYr.charAt(0)=="0" && strYr.length>1) {
			strYr=strYr.substring(1);
		}
	}
	
	//Parse the passed day, month and year to an integer
	month=parseInt(strMonth);
	day=parseInt(strDay);
	year=parseInt(strYr);
	
	// "0" (zero) is the first month (January) of a year.
	// Therefor, you should subtract 1 from the month value 
	// passedin the  form.
	var dateToCheck = new Date(year, (month-1), day);
	
	var today = new Date();
	var curr_year = today.getFullYear();
	var curr_month = today.getMonth();
	var curr_day = today.getDate();

	var beforeYear = curr_year - before;
	var afterYear = curr_year + after;

	var beforeDate=new Date();
	beforeDate.setFullYear(beforeYear,curr_month,curr_day);
	
	var afterDate=new Date();
	afterDate.setFullYear(afterYear,curr_month,curr_day);	
	
	
	if (pos1==-1 || pos2==-1){
		alert("The date format should be : mm/dd/yyyy");
		return false;
	}
	else if (strMonth.length<1 || month<1 || month>12) {
		alert("Please enter a valid month");
		return false;
	}
	else if (strDay.length<1 || day<1 || day>31 || (month==2 && day>daysInFebruary(year)) || day > daysInMonth[month]) {
		alert("Please enter a valid day");
		return false;
	}
	else if (strYear.length != 4 || year==0) {
		alert("Please enter a valid 4 digit year");
		return false;
	}
	else if (dtStr.indexOf(dtCh,pos2+1)!=-1 || isInteger(stripCharsInBag(dtStr, dtCh))==false) {
		alert("Please enter a valid date");
		return false;
	}
	else if (dateToCheck < beforeDate || dateToCheck > afterDate) {
		alert("Please provide a surgery date that is between " + before 
			+ " years ago today and " + after + " years in the future.");
		return false;
	}
	else if (dateToCheck < today) {
		return confirm("You entered a date in the past. Did you already have your surgery?");
	}
	
	return true;
}


/**
Finding the Element for given ID.
This is created for HMI 2.0 expandable stories

oulupinar 08/06/2009 initial version
*/
function findElement(element_id) {
	if (document.getElementById && document.getElementById(element_id)) {
		return document.getElementById(element_id);
	} else {
		return false;
	}
}

/**
Hide the element for given id.
This is created for HMI 2.0 expandable stories

oulupinar 08/06/2009 initial version
*/
function hideElement(element_id) {
	element = findElement(element_id);
	if (element) {
		element.style.display = 'none';
		return element;
	} else {
		return false;
	}
}

/**
Show the element for given id.
This is created for HMI 2.0 expandable stories

oulupinar 08/06/2009 initial version
*/
function showElement(element_id) {
	element = findElement(element_id);
	if (element) {
		element.style.display = '';
		return element;
	} else {
		return false;
	}
}

/**
Style the selected, (and unselected) tabs and show corresponding content.
Spins through all elements with the specified 'name' attribute, turning the selected
one on, and the unselected ones off. Uses the getElementsByName_iehack also implemented below.
Can be used for one or two sets of elements to be set according to one selected tab
Corresponding css styles must be named <xx>_on and <xx>_off.
Setting '_selected_tab' to 'All' will turn all on;

mcrockett 08/17/2009 initial version
	
**/
function tabSelect(_base_element_name, _selected_tab) {
	var _elementList = getElementsByName_iehack(_base_element_name);
	for (var i=0;i<_elementList.length;i++){
		var _thisElement=_elementList[i];
		if((_thisElement.id == _base_element_name+'_'+_selected_tab) || (_selected_tab =='AllOn')){
			_thisElement.className = _base_element_name+'_on';
		} else {
			_thisElement.className = _base_element_name+'_off';
		}
	}
}
//Or do two at a time if you prefer
//Setting 'selected_tab' to 'All' will turn all base_element_name_1 and base_element_name_2 off;
function tabSelect2(base_element_name_1, base_element_name_2, selected_tab) {
	tabSelect(base_element_name_1, selected_tab);
	if (selected_tab == 'AllOn'){
		selected_tab = 'AllOff';
	}
	tabSelect(base_element_name_2, selected_tab);
}

function getElementsByName_iehack(name) {
    var elem = document.getElementsByTagName("div");
    var arr = new Array();
    for(i = 0,iarr = 0; i < elem.length; i++) {
         att = elem[i].getAttribute("name");
         if(att == name) {
              arr[iarr] = elem[i];
              iarr++;
         }
    }
    return arr;
}

/* LMISHRA:: Adding support for expandable div elements using JQuery 
 * so that this functionality is accessible via keyboard clicks 
 * As of now, only Depression guides have been updated to use these.
 * */

$(document).ready(function() {
    
    $('#dep_co_thoughts_expand_button').click(function() {
  	  	$("#dep_co_thoughts_more").slideToggle();
  	  	$("#dep_co_thoughts_expand_button").toggleClass("full_content_link");
  	  	$("#dep_co_thoughts_expand_button").toggleClass("partial_content_link");
  	  	$("#dep_co_thoughts_collapse_button").toggleClass("full_content_link");
  	  	$("#dep_co_thoughts_collapse_button").toggleClass("partial_content_link");
  	});
    
    $('#dep_co_thoughts_collapse_button').click(function() {
    	$("#dep_co_thoughts_more").slideToggle();
    	$("#dep_co_thoughts_expand_button").toggleClass("full_content_link");
    	$("#dep_co_thoughts_expand_button").toggleClass("partial_content_link");
    	$("#dep_co_thoughts_collapse_button").toggleClass("full_content_link");
    	$("#dep_co_thoughts_collapse_button").toggleClass("partial_content_link");
    });
    
    $('#dep_co_patterns_expand_button').click(function() {
    	$("#dep_co_patterns_more").slideToggle();
    	$("#dep_co_patterns_expand_button").toggleClass("full_content_link");
    	$("#dep_co_patterns_expand_button").toggleClass("partial_content_link");
    	$("#dep_co_patterns_collapse_button").toggleClass("full_content_link");
    	$("#dep_co_patterns_collapse_button").toggleClass("partial_content_link");
    });
      
    $('#dep_co_patterns_collapse_button').click(function() {
      	$("#dep_co_patterns_more").slideToggle();
      	$("#dep_co_patterns_expand_button").toggleClass("full_content_link");
      	$("#dep_co_patterns_expand_button").toggleClass("partial_content_link");
      	$("#dep_co_patterns_collapse_button").toggleClass("full_content_link");
      	$("#dep_co_patterns_collapse_button").toggleClass("partial_content_link");
    });
    
    $('#dep_co_friends_expand_button').click(function() {
      	$("#dep_co_friends_more").slideToggle();
      	$("#dep_co_friends_expand_button").toggleClass("full_content_link");
      	$("#dep_co_friends_expand_button").toggleClass("partial_content_link");
      	$("#dep_co_friends_collapse_button").toggleClass("full_content_link");
      	$("#dep_co_friends_collapse_button").toggleClass("partial_content_link");
    });
    
    $('#dep_co_friends_collapse_button').click(function() {
      	$("#dep_co_friends_more").slideToggle();
      	$("#dep_co_friends_expand_button").toggleClass("full_content_link");
      	$("#dep_co_friends_expand_button").toggleClass("partial_content_link");
      	$("#dep_co_friends_collapse_button").toggleClass("full_content_link");
      	$("#dep_co_friends_collapse_button").toggleClass("partial_content_link");
    });
    
    $('#dep_co_act_ideas_expand_button').click(function() {
      	$("#dep_co_act_ideas_more").slideToggle();
      	$("#dep_co_act_ideas_expand_button").toggleClass("full_content_link");
      	$("#dep_co_act_ideas_expand_button").toggleClass("partial_content_link");
      	$("#dep_co_act_ideas_collapse_button").toggleClass("full_content_link");
      	$("#dep_co_act_ideas_collapse_button").toggleClass("partial_content_link");
    });
    
    $('#dep_co_act_ideas_collapse_button').click(function() {
      	$("#dep_co_act_ideas_more").slideToggle();
      	$("#dep_co_act_ideas_expand_button").toggleClass("full_content_link");
      	$("#dep_co_act_ideas_expand_button").toggleClass("partial_content_link");
      	$("#dep_co_act_ideas_collapse_button").toggleClass("full_content_link");
      	$("#dep_co_act_ideas_collapse_button").toggleClass("partial_content_link");
    });
    
});

/*
	Developed by Robert Nyman, http://www.robertnyman.com
	Code/licensing: http://code.google.com/p/getelementsbyclassname/
*/	
var getElementsByClassName = function (className, tag, elm){
	if (document.getElementsByClassName) {
		getElementsByClassName = function (className, tag, elm) {
			elm = elm || document;
			var elements = elm.getElementsByClassName(className),
				nodeName = (tag)? new RegExp("\\b" + tag + "\\b", "i") : null,
				returnElements = [],
				current;
			for(var i=0, il=elements.length; i<il; i+=1){
				current = elements[i];
				if(!nodeName || nodeName.test(current.nodeName)) {
					returnElements.push(current);
				}
			}
			return returnElements;
		};
	}
	else if (document.evaluate) {
		getElementsByClassName = function (className, tag, elm) {
			tag = tag || "*";
			elm = elm || document;
			var classes = className.split(" "),
				classesToCheck = "",
				xhtmlNamespace = "http://www.w3.org/1999/xhtml",
				namespaceResolver = (document.documentElement.namespaceURI === xhtmlNamespace)? xhtmlNamespace : null,
				returnElements = [],
				elements,
				node;
			for(var j=0, jl=classes.length; j<jl; j+=1){
				classesToCheck += "[contains(concat(' ', @class, ' '), ' " + classes[j] + " ')]";
			}
			try	{
				elements = document.evaluate(".//" + tag + classesToCheck, elm, namespaceResolver, 0, null);
			}
			catch (e) {
				elements = document.evaluate(".//" + tag + classesToCheck, elm, null, 0, null);
			}
			while ((node = elements.iterateNext())) {
				returnElements.push(node);
			}
			return returnElements;
		};
	}
	else {
		getElementsByClassName = function (className, tag, elm) {
			tag = tag || "*";
			elm = elm || document;
			var classes = className.split(" "),
				classesToCheck = [],
				elements = (tag === "*" && elm.all)? elm.all : elm.getElementsByTagName(tag),
				current,
				returnElements = [],
				match;
			for(var k=0, kl=classes.length; k<kl; k+=1){
				classesToCheck.push(new RegExp("(^|\\s)" + classes[k] + "(\\s|$)"));
			}
			for(var l=0, ll=elements.length; l<ll; l+=1){
				current = elements[l];
				match = false;
				for(var m=0, ml=classesToCheck.length; m<ml; m+=1){
					match = classesToCheck[m].test(current.className);
					if (!match) {
						break;
					}
				}
				if (match) {
					returnElements.push(current);
				}
			}
			return returnElements;
		};
	}
	return getElementsByClassName(className, tag, elm);
};