/** Functions that go along with questions/questionnaire */

/** limitTextAreaSize()
  * limits the maximum amount of characters that can be typed into a textarea
  */
function textAreaSize(sourcefield, destfield, maxlen) {
	
	if (sourcefield.value.length > maxlen) {
		sourcefield.value = sourcefield.value.substring(0, maxlen);
	}
	destfield.value = sourcefield.value.length  + " of " + maxlen;
}

var space = "   ";
var checkSubmit = false;
function checkIfClicked(){
	if(!checkSubmit){
		checkSubmit = true;
		return checkSubmit;
	}else{
		return !checkSubmit;
	}
}

function resetRadioColumn(selected_radio_name,radio_input_collection,radio_option_index) {
	try {
		for (i=0;i<radio_input_collection.length;i++) {
			var radio_name = radio_input_collection[i];
			if (radio_name != selected_radio_name) {
				eval("document.forms[0]." + radio_name + "[radio_option_index].checked=\"\"");
			}
		}
	} catch(e) {
		//don't do anything.  we'll just have to rely on the server side validation.
	}
}

/*
	for use with question types that have replaced a series of radio buttons 
	that use a scale (ex. 1-5, 0-10) with images that populate the value of a 
	hidden text field.  This is currently used by ImageRadioScaleWithText and
	ImageRadioScaleWithSideLabels. 
*/
function jsImageRadioScaleClick(optionIndex, inputName, optionClassPrefix, scaleStart, scaleEnd) {
	var selectedValueText = (arguments[5] != 'undefined' && arguments[5] != null) ? arguments[5] : "";
	var notSelectedValueText = (arguments[6] != 'undefined' && arguments[6] != null) ? arguments[6] : "";
	var useValueTextOptions = (selectedValueText != "" && notSelectedValueText != "");
	
	document.getElementById(inputName + "_image_radio").value = optionIndex;
	document.getElementById(inputName + "_" + optionIndex).className = optionClassPrefix + optionIndex + "_selected";
	if (useValueTextOptions) document.getElementById(inputName + "_" + optionIndex).value = optionIndex + " " + selectedValueText;
	for (i=scaleStart;i<=scaleEnd;i++) {
		if (i != optionIndex) { 
			document.getElementById(inputName + "_" + i).className = optionClassPrefix + i + "_unselected";
			if (useValueTextOptions) document.getElementById(inputName + "_" + i).value = i + " " + notSelectedValueText;
		}
	}
}
/*
for use with question types that have replaced a series of radio buttons 
that use a list (ex. poor, fine, good, excellent) with images that populate
 the value of a hidden text field.  This is currently used by ImageRadioList.
 
* jgerman	04/07/2010 Initial version.<br />
* jgerman	06/17/2010 Automated testing scripts want ItemCD_ResponseCD not ItemCD_index for id<br />
*/
function jsImageRadioListClick(optionIndex, optionValue, inputName, optionClassPrefix, scaleStart, scaleEnd) {
	var selectedValueText = (arguments[6] != 'undefined' && arguments[6] != null) ? arguments[6] : "";
	var notSelectedValueText = (arguments[7] != 'undefined' && arguments[7] != null) ? arguments[7] : "";
	var useValueTextOptions = (selectedValueText != "" && notSelectedValueText != "");
	
	/* find value for the selected option in the option's hidden "_selected" element */
	var selectedOptionValue = document.getElementById(inputName + "_" + optionValue + "_selected").innerHTML;
	/* set the select value for this question so it can be stored into the DB */
	document.getElementById(inputName + "_image_radio").value = selectedOptionValue;
	/* Change the css class on the selected option to the "_selected" class */
	document.getElementById(inputName + "_" + optionValue).className = optionClassPrefix + optionIndex + "_selected";
	/* Change the selected option's display text for screen readers to have selected value text in it */
	if (useValueTextOptions) {
		var currentText = document.getElementById(inputName + "_" + optionValue).value;
		/* use \n character at beginning so 'selected' in 'unselected' isn't always replaced independent of the 'un' */
		currentText = currentText.replace('\n' + notSelectedValueText, '\n' + selectedValueText);
		document.getElementById(inputName + "_" + optionValue).value = currentText;
	}
	/* Change the css class on all the other options to the "_unselected" class */
	for (i=scaleStart;i<=scaleEnd;i++) {
		if (i != optionIndex) { 
			var arrayNum = i - scaleStart;
			var parentQuestion = document.getElementById('Q_' + inputName);
			var nextID = parentQuestion.getElementsByTagName('input')[arrayNum].id;

			/* Change the css class on all the other options to the "_unselected" class */
			document.getElementById(nextID).className = optionClassPrefix + i + "_unselected";

			/* Change the display text on all the other options to unselected value text in then for screen readers */
			var currentText = document.getElementById(nextID).value;
			/* use \n character at beginning so 'selected' in 'unselected' isn't always replaced independent of the 'un' */
			currentText = currentText.replace('\n' + selectedValueText, '\n' + notSelectedValueText);
			document.getElementById(nextID).value = currentText;
		}
	}
}

/* Hip BodyMap functions and vars */
var oldChecked, oldStiffness, oldSharp, oldDull, oldWeakness, oldDecMotion, oldOther;
var newChecked, newStiffness, newSharp, newDull, newWeakness, newDecMotion, newOther;
var optionClassPrefix = "bodymap_checkbox_";
var locationPrefix ="Sympt"

function jsBodyMapLocationsClick(inputName, setName, locationName) {
	//inputname: HipPainLoc_LHip
	//setName: HipPainLoc
	//locationName: LHip

	oldChecked = document.getElementById(inputName).value;
	oldStiffness = ((document.getElementById(locationPrefix+locationName+"_Stiffnesstrue").checked)==true ? true : false);
	oldSharp = ((document.getElementById(locationPrefix+locationName+"_Sharptrue").checked)==true ? true : false);
	oldDull = ((document.getElementById(locationPrefix+locationName+"_Dulltrue").checked)==true ? true : false);
	oldWeakness = ((document.getElementById(locationPrefix+locationName+"_Weaknesstrue").checked)==true ? true : false);
	oldDecMotion = ((document.getElementById(locationPrefix+locationName+"_DecMotiontrue").checked)==true ? true : false);
	oldOther = ((document.getElementById(locationPrefix+locationName+"_Othertrue").checked)==true ? true : false);
	
	document.getElementById("bodymap_"+setName+"_"+locationPrefix+locationName).style.display = "block";
	try {document.forms[0].Next.style.display= "none";} catch(error) {}

	//document.getElementById(inputName).value = oldChecked;
}

function jsBodyMapSubmitSymptomsClick(parentName, locationName) {
	newStiffness = ((document.getElementById(locationPrefix+locationName+"_Stiffnesstrue").checked)==true ? true : false);
	newSharp = ((document.getElementById(locationPrefix+locationName+"_Sharptrue").checked)==true ? true : false);
	newDull = ((document.getElementById(locationPrefix+locationName+"_Dulltrue").checked)==true ? true : false);
	newWeakness = ((document.getElementById(locationPrefix+locationName+"_Weaknesstrue").checked)==true ? true : false);
	newDecMotion = ((document.getElementById(locationPrefix+locationName+"_DecMotiontrue").checked)==true ? true : false);
	newOther = ((document.getElementById(locationPrefix+locationName+"_Othertrue").checked)==true ? true : false);
	
	newChecked = (newStiffness || newSharp || newDull || newWeakness || newDecMotion || newOther);
	
	var stringVal;
	
	if (newChecked) {
		
		suffix = "_selected";
		stringVal = "true";
		document.getElementById("bodymap_summary_"+parentName+"_"+locationName).className = "bodymap_summary_loc_selected";
		
		if (newStiffness) {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Stiffness").className = "bodymap_summary_symp_selected";
		} else {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Stiffness").className = "bodymap_summary_symp_unselected";
		}
		
		if (newSharp) {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Sharp").className = "bodymap_summary_symp_selected";
		} else {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Sharp").className = "bodymap_summary_symp_unselected";
		}
		
		if (newDull) {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Dull").className = "bodymap_summary_symp_selected";
		} else {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Dull").className = "bodymap_summary_symp_unselected";
		}
		
		if (newWeakness) {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Weakness").className = "bodymap_summary_symp_selected";
		} else {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Weakness").className = "bodymap_summary_symp_unselected";
		}
		
		if (newDecMotion) {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_DecMotion").className = "bodymap_summary_symp_selected";
		} else {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_DecMotion").className = "bodymap_summary_symp_unselected";
		}
		
		if (newOther) {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Other").className = "bodymap_summary_symp_selected";
		} else {
			document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Other").className = "bodymap_summary_symp_unselected";
		}
	}
	else {
		suffix = "_unselected";
		stringVal = "";
		document.getElementById("bodymap_summary_"+parentName+"_"+locationName).className = "bodymap_summary_loc_unselected";
		document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Stiffness").className = "bodymap_summary_symp_unselected";
		document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Sharp").className = "bodymap_summary_symp_unselected";
		document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Dull").className = "bodymap_summary_symp_unselected";
		document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Weakness").className = "bodymap_summary_symp_unselected";
		document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_DecMotion").className = "bodymap_summary_symp_unselected";
		document.getElementById("bodymap_summary_"+locationPrefix+locationName+"_Other").className = "bodymap_summary_symp_unselected";
	}
	
	document.getElementById(parentName+"_"+locationName).value = stringVal;
	document.getElementById(optionClassPrefix+parentName+"_"+locationName).className = optionClassPrefix+parentName+"_"+locationName+ suffix;
	document.getElementById("bodymap_"+parentName+"_"+locationPrefix+locationName).style.display = "none";
	try {document.forms[0].Next.style.display= "block";} catch(error) {}
}

function jsBodyMapCancelSymptomsClick(parentName, locationName) {
	//parentName: HipPainLoc
	//locationName: LHip
	
	document.getElementById(parentName+"_"+locationName).value = oldChecked;
	document.getElementById(locationPrefix+locationName+"_Stiffnesstrue").checked = oldStiffness
	document.getElementById(locationPrefix+locationName+"_Sharptrue").checked =oldSharp
	document.getElementById(locationPrefix+locationName+"_Dulltrue").checked = oldDull
	document.getElementById(locationPrefix+locationName+"_Weaknesstrue").checked = oldWeakness
	document.getElementById(locationPrefix+locationName+"_DecMotiontrue").checked = oldDecMotion
	document.getElementById(locationPrefix+locationName+"_Othertrue").checked = oldOther
	
	//alert(parentName+"_"+locationName);
	document.getElementById("bodymap_"+parentName+"_"+locationPrefix+locationName).style.display = "none";
	try {document.forms[0].Next.style.display= "block";} catch(error) {}
}

function jsBodyMapLocationsMouseover(setName, locationName) {
	document.getElementById(setName+"_Locations_RO_"+locationName).style.display = "block";
}

function jsBodyMapLocationsMouseout(setName, locationName) {
	document.getElementById(setName+"_Locations_RO_"+locationName).style.display = "none";
}